;; prolog-mode loader
;; Thierry.Martinez@inria.fr
;; under GPLv3

(add-to-list
 'load-path
 (or
  (and load-in-progress (file-name-directory load-file-name))
  (file-name-directory (buffer-file-name))))

(autoload 'prolog-mode "prolog-mode" "Major mode for editing Prolog code." t)

(defun chr-mode ()
  "Specific prolog mode for CHR which uses SWI by default"
  (interactive)
  (prolog-mode 'swi))

(defun is-perl ()
  (save-excursion
    (goto-char 1)
    (looking-at "#![^\n]*perl")))

(defun prolog-or-perl-mode ()
  (if (is-perl)
      (perl-mode)
    (prolog-mode)))

(setq auto-mode-alist (append '(
                                ("\\.pro$" . prolog-mode)
                                ("\\.pl$" . prolog-or-perl-mode)
                                ("\\.chr$" . chr-mode)
                                )
                              auto-mode-alist))
(provide 'prolog)
